<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_TransferBookingInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_TransferBookingInfo extends AbstractStructArrayBase
{
    /**
     * The TransferBookingInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_TransferBookingInfo[]
     */
    public $TransferBookingInfo;
    /**
     * Constructor method for ArrayOfJP_TransferBookingInfo
     * @uses ArrayOfJP_TransferBookingInfo::setTransferBookingInfo()
     * @param \StructType\JP_TransferBookingInfo[] $transferBookingInfo
     */
    public function __construct(array $transferBookingInfo = array())
    {
        $this
            ->setTransferBookingInfo($transferBookingInfo);
    }
    /**
     * Get TransferBookingInfo value
     * @return \StructType\JP_TransferBookingInfo[]|null
     */
    public function getTransferBookingInfo()
    {
        return $this->TransferBookingInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setTransferBookingInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransferBookingInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransferBookingInfoForArrayConstraintsFromSetTransferBookingInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_TransferBookingInfoTransferBookingInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_TransferBookingInfoTransferBookingInfoItem instanceof \StructType\JP_TransferBookingInfo) {
                $invalidValues[] = is_object($arrayOfJP_TransferBookingInfoTransferBookingInfoItem) ? get_class($arrayOfJP_TransferBookingInfoTransferBookingInfoItem) : sprintf('%s(%s)', gettype($arrayOfJP_TransferBookingInfoTransferBookingInfoItem), var_export($arrayOfJP_TransferBookingInfoTransferBookingInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransferBookingInfo property can only contain items of type \StructType\JP_TransferBookingInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransferBookingInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransferBookingInfo[] $transferBookingInfo
     * @return \ArrayType\ArrayOfJP_TransferBookingInfo
     */
    public function setTransferBookingInfo(array $transferBookingInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($transferBookingInfoArrayErrorMessage = self::validateTransferBookingInfoForArrayConstraintsFromSetTransferBookingInfo($transferBookingInfo))) {
            throw new \InvalidArgumentException($transferBookingInfoArrayErrorMessage, __LINE__);
        }
        $this->TransferBookingInfo = $transferBookingInfo;
        return $this;
    }
    /**
     * Add item to TransferBookingInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransferBookingInfo $item
     * @return \ArrayType\ArrayOfJP_TransferBookingInfo
     */
    public function addToTransferBookingInfo(\StructType\JP_TransferBookingInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_TransferBookingInfo) {
            throw new \InvalidArgumentException(sprintf('The TransferBookingInfo property can only contain items of type \StructType\JP_TransferBookingInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransferBookingInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_TransferBookingInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransferBookingInfo
     */
    public function getAttributeName()
    {
        return 'TransferBookingInfo';
    }
}
